% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dashboard.R
\name{sd_dashboard}
\alias{sd_dashboard}
\title{Launch Survey Dashboard}
\usage{
sd_dashboard(gssencmode = "prefer")
}
\arguments{
\item{gssencmode}{Character string. The GSS encryption mode for the database
connection. Defaults to \code{"prefer"}. Set to \code{"disable"} if you're having
connection issues on a secure connection like a VPN.}
}
\value{
Launches a Shiny application with the survey dashboard.
The function does not return a value; it is called for its side effects
of opening the dashboard interface.
}
\description{
This function creates a comprehensive dashboard for survey data analysis
with two main tabs:
\itemize{
\item Dashboard: Displays survey statistics, response trends, and a full
response data table
\item Settings: Provides interface for updating database connection settings
}
}
\details{
Opens an interactive dashboard to view and analyze survey responses
using a Shiny dashboard interface.

The dashboard offers the following features:
\itemize{
\item Summary value boxes showing total responses, daily average,
completion rate, and average rating
\item Response trend plot with daily and cumulative responses
\item Downloadable survey responses data table
\item Database connection configuration and testing
}
}
\examples{
\dontrun{
# Launch the survey dashboard with default settings
sd_dashboard()

# Launch with disabled GSS encryption (for VPN connections)
sd_dashboard(gssencmode = "disable")
}

}
